
/* GP Symbol table support header file.
   Copyright 2014-2016	Molnár Károly
*/

#pragma once

FUNC(gp_hash_t*) gp_symbol_make_hash_table(gp_object_t *Object);

extern const gp_symbol_t *gp_symbol_find(const gp_object_t *Object, const char *Section_name,
                                         gp_symvalue_t Symbol_value);

EXTERN_C gp_symbol_t** gp_symbol_make_label_array(gp_section_t *Section, unsigned Org_to_byte_shift,
                                                unsigned *Num_labels);

EXTERN_C gp_symbol_t** gp_symbol_make_register_array(gp_object_t *Object, unsigned &Num_registers);

EXTERN_C gp_symbol_t* gp_symbol_find_by_value(gp_symbol_t **Array, unsigned Num_symbols, gp_symvalue_t Value);

EXTERN_C bool gp_symbol_delete_by_value(gp_symbol_t **Array, unsigned *Num_symbols, gp_symvalue_t Value);
